#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

typedef struct _node{
	int value;
	struct _node *next;
} node;

node *add(int val, node *root){
	node *p = malloc(sizeof(node));
	assert(p != NULL);
	p->value = val;
	p->next = root;
	return p;
}

node *addSortedRecursive(int val, node *root){
	if(root == NULL || root->value > val) //exit condition
		return add(val, root);
	root->next = addSortedRecursive(val, root->next);
	return root;
}

node *addSorted(int val, node *root){
	if(root == NULL || root->value > val)
		return add(val, root);
	node *p;
	for(p = root; p != NULL; p = p->next)
		if(p->next == NULL || p->next->value > val){
			p->next = add(val, p->next);
			break;
		}
	return root;
}

void print(node *root){
	node *p;
	for(p = root; p != NULL; p = p->next)
		printf("%d\n", p->value);
}

#define MAX 10000

int main(void){
	int i;
	node *root = NULL;
	for(i = 0; i < MAX; i++)
		root = addSortedRecursive(rand() % (2 * MAX), root);
	print(root);
	return 0;
}